# XXX - tools/boottool should be packaged seperately as
# perl-Linux-Bootloader
## filter_from_requires |client/tools/boottool$|d
%{?filter_setup:
%filter_requires_in %{_datadir}/autotest/client/tools/boottool$
%filter_setup
}

Name: autotest
Version: 0.13.0
Release: 4%{?dist}
Summary: Framework for fully automated testing
Group: Applications
License: GPLv2 and BSD and LGPLv2.1+
# All content is GPLv2 unless otherwise stated.
# Part of frontend/afe/feeds/feed.py is BSD licensed code from Django
# frontend/afe/json_rpc is a heavily modified fork of the dead
# http://json-rpc.org/wiki/python-json-rpc which is LGPLv2.1+
URL: http://autotest.kernel.org/
BuildArch: noarch
# The source is pulled from upstream git branch.  Use the
# following commands to generate the tarball:
#  git clone -b django13 git://github.com/lmr/autotest.git autotest-0.13.0
#  tar -cjvf autotest-notests-0.13.0.tar.bz2  --exclude=tests --exclude=.git autotest-0.13.0
# For official upstream releases, the following Source URL can be used
# XXX: Use a tarball without the tests
# XXX: Source0: http://test.kernel.org/releases/%{version}/%{name}-notests-%{version}.tar.bz2
Source0: http://test.kernel.org/releases/%{version}/%{name}-notests-%{version}.tar.bz2
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
# Not sent upstream, specific to Fedora and FHS guidelines
Patch1: 0001-Use-system-gwt-install.patch
# Not sent upstream, specific to Fedora and FHS guidelines
Patch2: 0002-Main-apache-configuration-adjustments-for-Fedora-bas.patch
# Not sent upstream, specific to Fedora and FHS guidelines
Patch3: 0003-Change-usr-local-autotest-to-usr-share-autotest.patch
# Not sent upstream, specific to Fedora
Patch4: 0004-Add-README-for-deployment-on-Fedora.patch
# Not sent upstream, specific to Fedora
Patch5: 0005-Stop-the-build_externals-script-from-being-called-at.patch
# Upstream - http://test.kernel.org/pipermail/autotest/2011-July/009028.html
Patch6: 0006-Ignore-KeyError-on-double-close-for-logging-handler.patch
# Upstream - http://autotest.kernel.org/changeset/5492
Patch7: 0007-Fix-various-packager-issues.-Add-options-to-global_config.patch

# The old client package was a subpackage and has ben replaced by the base
# package
Obsoletes: %{name}-client

Requires: python >= 2.4
BuildRequires: python >= 2.4
BuildRequires: gwt-devel >= 2.3.0
BuildRequires: java-openjdk
BuildRequires: git-core
# Packages needed during %post and %pre processing
Requires(post): openssh
Requires(pre): shadow-utils
# Ensure scp, rsync and sshd are available
Requires: openssh-clients
Requires: openssh-server
Requires: rsync


%description
Autotest is a framework for fully automated testing. It is designed primarily
to test the Linux kernel, though it is useful for many other functions such as
qualifying new hardware. It's an open-source project under the GPL and is used
and developed by a number of organizations, including Google, IBM, and many
others.

The autotest package provides the client harness capable of running autotest
jobs on a single system.


%package server
Summary: Server test harness and front-end for autotest
Group: Applications
Requires: %{name} = %{version}-%{release}
Requires: Django >= 1.3
Requires: gnuplot
Requires: httpd
Requires: mod_python
Requires: MySQL-python
Requires: numpy
Requires: python-atfork
Requires: python-crypto
Requires: python-imaging
Requires: python-matplotlib
Requires: python-paramiko
Requires: python-simplejson
Requires: python-setuptools
Requires: python-httplib2
Requires: gzip, bzip2, unzip
%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6
Requires(post): policycoreutils-python
%else
Requires(post): policycoreutils
%endif
# This is for /sbin/service
Requires(preun): initscripts
Requires(postun): initscripts
# This is for /sbin/chkconfig
Requires(post): chkconfig
Requires(preun): chkconfig
# Include systemd-units for Fedora 15 and newer
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
BuildRequires: systemd-units
%endif


%description server
Autotest is a framework for fully automated testing. It is designed primarily
to test the Linux kernel, though it is useful for many other functions such as
qualifying new hardware. It's an open-source project under the GPL and is used
and developed by a number of organizations, including Google, IBM, and many
others.

The autotest-server package provides the server harness capable of running
autotest jobs on a single system.


%prep
%setup -q -n %{name}-notests-%{version}

# Use git to apply patches, so that permission changes work
git init
# Setup a committer
if [ -z "$GIT_COMMITTER_NAME" ]; then
    git config user.email "test@lists.fedoraproject.org"
    git config user.name "Fedora Quality Assurance"
fi
git add .
git commit -a -q -m 'Initial commit for %{version}'
# The below works in Fedora, but not yet in EL5
#git am -p1 %{patches}
# EL 5 version, stolen from Xorg, hold your nose
git am -p1 $(awk '/^Patch.*:/ { print "%{_sourcedir}/"$2 }' %{_specdir}/%{name}.spec)


%build
python utils/compile_gwt_clients.py -c 'autotest.EmbeddedSpreadsheetClient autotest.AfeClient autotest.TkoClient autotest.EmbeddedTkoClient'


%install
rm -rf %{buildroot}
# Top level dir
install -d %{buildroot}%{_datadir}/autotest
# Top level files
install -p -m 0644 -t %{buildroot}%{_datadir}/autotest common.py \
global_config.ini shadow_config.ini

# apache
# We only want the www dir and the configs go elsewhere
install -d %{buildroot}%{_datadir}/autotest/apache/www
install -d %{buildroot}%{_sysconfdir}/httpd/conf.d
install -d %{buildroot}%{_sysconfdir}/httpd/autotest.d
# We want all of apache configs (except for legacy apache-conf) so just use
# cp -a since install sucks.
cp -a apache/conf/* %{buildroot}%{_sysconfdir}/httpd/autotest.d
rm %{buildroot}%{_sysconfdir}/httpd/autotest.d/apache-conf
rm %{buildroot}%{_sysconfdir}/httpd/autotest.d/site-directives
rm %{buildroot}%{_sysconfdir}/httpd/autotest.d/all-directives
cp -a apache/apache-conf %{buildroot}%{_sysconfdir}/httpd/conf.d/autotest.conf

# cli
install -d %{buildroot}%{_datadir}/autotest/cli
cp -a cli/* %{buildroot}%{_datadir}/autotest/cli/

# database
install -d %{buildroot}%{_datadir}/autotest/database
cp -a database/* %{buildroot}%{_datadir}/autotest/database/

# client
install -d %{buildroot}%{_datadir}/autotest/client
# Remove any client/deps
rm -rf client/deps
# Remove any client/profilers, but leave the directory (required by
# client/common_lib/base_job.py)
rm -rf client/profilers/*
cp -a client/* %{buildroot}%{_datadir}/autotest/client/

# frontend
install -d %{buildroot}%{_datadir}/autotest/frontend
#XXX - exclude 'planner' until it is complete
rm -rf frontend/planner
cp -a frontend/* %{buildroot}%{_datadir}/autotest/frontend/

# logs
install -d %{buildroot}%{_datadir}/autotest/logs
cp -a logs/* %{buildroot}%{_datadir}/autotest/logs/

# mirror
install -d %{buildroot}%{_datadir}/autotest/mirror
cp -a mirror/* %{buildroot}%{_datadir}/autotest/mirror/

# packages
install -d %{buildroot}%{_datadir}/autotest/packages
cp -a packages/* %{buildroot}%{_datadir}/autotest/packages/

# results
install -d %{buildroot}%{_datadir}/autotest/results
cp -a results/* %{buildroot}%{_datadir}/autotest/results/

# scheduler
install -d %{buildroot}%{_datadir}/autotest/scheduler
cp -a scheduler/* %{buildroot}%{_datadir}/autotest/scheduler/
chmod +x %{buildroot}%{_datadir}/autotest/scheduler/monitor_db_babysitter

# conmux - Only the directory is required.  Conmux is provided by the 'conmux' package.
install -d %{buildroot}%{_datadir}/autotest/conmux

# server - omit self-test, tests, and samples
install -d %{buildroot}%{_datadir}/autotest/server/{control_segments,hosts,tmp}
find server/ -maxdepth 1 -type f -exec cp -a '{}' %{buildroot}%{_datadir}/autotest/server/ \;
cp -a server/control_segments/* %{buildroot}%{_datadir}/autotest/server/control_segments/
cp -a server/hosts/* %{buildroot}%{_datadir}/autotest/server/hosts/

# tko
install -d %{buildroot}%{_datadir}/autotest/tko/
cp -a tko/* %{buildroot}%{_datadir}/autotest/tko/

# utils
install -d %{buildroot}%{_datadir}/autotest/utils
# Package up everything but the unittest stuff and named_semaphore
find utils/ -maxdepth 1 -type f \! -name 'unittest_suite.py' -exec cp -a '{}' %{buildroot}%{_datadir}/autotest/utils/ \;

# Install systemd init script
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
install -d %{buildroot}%{_unitdir}
cp -a utils/autotestd.service %{buildroot}%{_unitdir}/
rm %{buildroot}%{_datadir}/autotest/utils/autotestd.service
%else
# Install SysV initscript instead
install -d %{buildroot}%{_sysconfdir}/rc.d/init.d
cp -a utils/autotest-rh.init %{buildroot}%{_sysconfdir}/rc.d/init.d/autotestd
rm %{buildroot}%{_datadir}/autotest/utils/autotest-rh.init
%endif

# Make symlink for cli tool(s)
install -d %{buildroot}%{_bindir}
ln -s %{_datadir}/autotest/cli/atest %{buildroot}%{_bindir}/
install -d %{buildroot}%{_sbindir}
ln -s %{_datadir}/autotest/scheduler/monitor_db_babysitter %{buildroot}%{_sbindir}/

# Make a dir for the autotest user ssh stuff
install -d %{buildroot}%{_datadir}/autotest/.ssh
# touch ssh files for ghosting
touch %{buildroot}%{_datadir}/autotest/.ssh/id_rsa
touch %{buildroot}%{_datadir}/autotest/.ssh/id_rsa.pub

# Remove files we don't need
find %{buildroot}%{_datadir}/autotest/ -name "*_unittest.py" -exec rm '{}' \;
find %{buildroot}%{_datadir}/autotest/ -name "*_test.py" -exec rm '{}' \;


%clean
rm -rf %{buildroot}


%pre
getent group autotest >/dev/null || groupadd -r autotest
getent passwd autotest >/dev/null || \
useradd -r -g autotest -d %{_datadir}/autotest -s /bin/bash \
-c "User account for the autotest harness" autotest
exit 0


%post
# install
if [ "$1" -eq 1 ] ; then
    su -c "ssh-keygen -q -t rsa -N '' -f %{_datadir}/autotest/.ssh/id_rsa" - autotest || exit 0
fi


%post server
# install
if [ "$1" -ge 1 ]; then
    semanage fcontext -a -t bin_t '%{_datadir}/autotest/tko(/.*cgi)?'
    restorecon %{_datadir}/autotest/tko/*
    /sbin/chkconfig --add autotestd >/dev/null 2>&1 || :
fi


%postun server
if [ "$1" -ge 1 ]; then
    /sbin/service autotestd condrestart >/dev/null 2>&1 || :
fi


%preun server
# uninstall
if [ $1 -eq 0 ]; then
    /sbin/service autotestd stop >/dev/null 2>&1
    /sbin/chkconfig --del autotestd >/dev/null 2>&1 || :
    /bin/systemctl disable autotestd.service >/dev/null 2>&1 || :
fi


%files
%defattr(-,autotest,autotest,-)
%doc %attr(-,root,root) DCO LICENSE CODING_STYLE README.fedora Documentation/*
%doc /usr/share/autotest/client/bin/self-test/README
%doc /usr/share/autotest/client/common_lib/README
%dir %{_datadir}/autotest
%{_datadir}/autotest/client


%files server
%defattr(-,autotest,autotest,-)
%doc /usr/share/autotest/logs/README
%doc /usr/share/autotest/packages/README
%doc /usr/share/autotest/results/README
# The top level dir in /usr/share is owned by client
%dir %{_datadir}/autotest/.ssh
%dir %{_sysconfdir}/httpd/autotest.d
%ghost %{_datadir}/autotest/.ssh/*
%{_datadir}/autotest/apache
%{_datadir}/autotest/cli
%{_datadir}/autotest/conmux
%{_datadir}/autotest/database
%{_datadir}/autotest/frontend
%{_datadir}/autotest/logs
%{_datadir}/autotest/mirror
%{_datadir}/autotest/packages
%{_datadir}/autotest/results
%{_datadir}/autotest/scheduler
%{_datadir}/autotest/server
%{_datadir}/autotest/tko
%{_datadir}/autotest/utils
%{_datadir}/autotest/common.py*
%{_bindir}/atest
%{_sbindir}/monitor_db_babysitter
# Only include the following if support for build_externals is enabled (see
# patch5)
# %{_datadir}/autotest/ExternalSource
# %{_datadir}/autotest/site-packages
# Include systemd service file on Fedora 15 and newer
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
%{_unitdir}/autotestd.service
%else
%{_sysconfdir}/rc.d/init.d/autotestd
%endif
%config(noreplace) %{_datadir}/autotest/global_config.ini
%config(noreplace) %{_datadir}/autotest/shadow_config.ini
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/httpd/autotest.d/*
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/httpd/conf.d/autotest.conf


%changelog
* Wed Jul 12 2011 James Laska <jlaska@redhat.com> - 0.13.0-4
- Add upstream patch http://test.kernel.org/pipermail/autotest/2011-July/009028.html
- Add upstream patch http://autotest.kernel.org/changeset/5492

* Wed Jul 06 2011 James Laska <jlaska@redhat.com> - 0.13.0-3
- Updated build_externals disable patch

* Thu Jun 30 2011 James Laska <jlaska@redhat.com> - 0.13.0-2
- Updated s/local/share/ patch

* Thu Jun 23 2011 James Laska <jlaska@redhat.com> - 0.13.0-1
- Update to 0.13.0 release

* Mon Jun 13 2011 James Laska <jlaska@redhat.com> - 0.13.0-0.3.20110607
- Correct policycoreutils-python requires

* Tue Jun 07 2011 James Laska <jlaska@redhat.com> - 0.13.0-0.2.20110607
- Adjust autotestd.service to ensure proper Group= is used
- Additional autotest-server requirements added

* Tue May 31 2011 James Laska <jlaska@redhat.com> - 0.13.0-0.1.20110531
- Package pre-0.13.0 release
- Updated and reduced local patchset
- Remove client/deps and client/profilers/* from package
- Include autotestd.service systemd file
- frontend/settings.py - Disable frontend.planner until complete

* Wed Apr 13 2011 James Laska <jlaska@redhat.com> - 0.12.0-4
- Add filter_requires_in for boottool (perl-Linux-Bootloader)
- Patch for proper systemd support (changeset 5300)

* Tue Jan 25 2011 James Laska <jlaska@redhat.com> - 0.12.0-3
- Add %requires for rsync, openssh-{clients,server}
- Add BuildRequires on python

* Thu Jan 20 2011 James Laska <jlaska@redhat.com> - 0.12.0-2
- Change %requires to java-openjdk

* Tue Jun 22 2010 James Laska <jlaska@redhat.com> - 0.12.0-1
- New upstream release autotest-0.12.0
- Updated patchset
- Combine autotest and autotest-client
- Rename initscript to autotestd
- Add conmux directory, required even if conmux isn't used

* Thu Nov 19 2009 James Laska <jlaska@redhat.com> - 0.11.0-4
- Updated Patch4 (0004-Change-usr-local-to-usr-share.patch) so that
  global_config.ini also uses /usr/share/autotest

* Fri Nov 13 2009 James Laska <jlaska@redhat.com> - 0.11.0-3
- Moved autotest user creation into autotest-client package

* Tue Oct 30 2009 James Laska <jlaska@redhat.com> - 0.11.0-2
- Updated patch2 - new_tko/tko/graphing.py uses simplejson also
- Updated patch3 - correct http log paths
- Updated patch5 - background patch to work against monitor_db_babysitter
- Updated patch7 - RH style initscript updated to use monitor_db_babysitter
- Add patch9 to correct new_tko models.py issue with older django

* Tue Aug 25 2009 Jesse Keating <jkeating@redhat.com> - 0.11.0-1
- Update for 0.11
- Drop unneeded patches
- Re-order patches with new upstream code set

* Fri Jul 31 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-8
- Fix AFE loading with the missing site_rpc_interface

* Tue Jul 14 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-7
- Remove the all-directives file, it is now redundant

* Wed Jul 08 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-6
- Move apache config files into /etc/
- Drop some unneeded files
- Set permissions accordingly
- Remove unneeded #! and add a missing one

* Tue Jul 07 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-5
- Make README.fedora a patch to the source code
- Make initscript a patch to the source code
- re-work background patch to be git compliant
- Remove macros for install
- Drop release level requirement on autotest-client.  Version is good enough

* Mon Jun 29 2009 James Laska <jlaska@redhat.com> - 0.10.0-4
- Add README.fedora
- Add autotest initscript
- Make scheduler/monitor_db.py executable

* Sat Jun 27 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-3
- Move ssh key into autotest home .ssh/ and name it generically
- Ghost the ssh dir
- More selinux fixes

* Fri Jun 26 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-2
- Patch path issues
- Set a shell for the autotest user to allow running init script
- Fix ssh key generation to run as autotest user
- SELinux fixes

* Tue Jun 16 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-1
- Initial attempt at packaging, adding to start from Lucas Meneghel Rodrigues
  <lmr@redhat.com>

